
#include <propeller.h>
#include "max147.h"

#define set_dira(bits) DIRA |= (bits)
#define clr_dira(bits) DIRA &= ~(bits)
#define set_outa(bits) OUTA |= (bits)
#define clr_outa(bits) OUTA &= ~(bits)
#define get_ina() INA


void initMAX147()
{
 set_dira(SCLK);  // output
 set_dira(nCS);	  // output
 set_dira(DIN);	  // output ;from Max147 view in
 
 set_outa(nCS);	  // CS:H
 clr_outa(SCLK);  // SCLK L
 clr_outa(DIN);   // DIN: L
}

unsigned short 
readMAX147(unsigned char controll)
{
  unsigned char rb2 = 0;
  unsigned char rb3 = 0;
  unsigned char ticks;
  unsigned short result;
   
  clr_outa(nCS);		// CS:LOW
  
  for (ticks = 0; ticks < 8; ticks ++)
  {
   	  if(controll & (0x80 >> ticks)) 
	    set_outa(DIN); 
	  else 
	    clr_outa(DIN);
	  set_outa(SCLK);
	  clr_outa(SCLK);
  }
  
  for (ticks = 0; ticks < 8; ticks ++)
  {
   	  clr_outa(DIN);
	  set_outa(SCLK);
	  clr_outa(SCLK);
	  if(get_ina() & DOUT) 
	    rb2 |= (0x80 >> ticks);
  }
  
  for (ticks = 0; ticks < 8; ticks ++)
  {
      clr_outa(DIN);
	  set_outa(SCLK);
	  clr_outa(SCLK);
	  if(get_ina() & DOUT) 
	    rb3 |= (0x80 >> ticks);
  }  
  
  set_outa(nCS);   // CS:H
  
  result = rb2;
  result = result << 4;
  rb3 = rb3 >> 4;
  result += rb3; 
  return (result);
}



